#   Copyright (C) 2003 Nicolas Centa
 
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2 of the
#   License, or (at your option) any later version.
 
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
 
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
#   USA

import MConfigParser
import re
import os
import os.path

def visit(arg, dirname, names):
    j = range(0,len(names))
    exp = re.compile(arg[1][0],arg[1][1])
    for i in j:
        if exp.match(names[i]) != None:
            path = os.path.normpath(dirname+'/'+names[i])
            if arg[1][2](path):
                arg[2] += [path]

def seek(path, pattern, list):
    arg = [path, pattern, list]
    os.path.walk(arg[0],visit,arg)
    
def cfg_get_keys(file,section,keys):
    c = MConfigParser.ConfigParser()
    c.read(file)
    i = 0
    s = section+str(0)
    r = []
    while c.has_section(s):
        st = [file]
        for j in range(len(keys)):
            st += [c.get(s,keys[j])]
        i += 1
        s = section+str(i)
        r += [st]
    return r

def get_fs_db(fspath):
    list = []
    seek(os.path.normpath(fspath+'/AIRCRAFT/'),
         ['aircraft.cfg|panel.cfg|sound.cfg',re.I,os.path.isfile],list)
    air = re.compile('aircraft.cfg',re.I)
    air_list = []
    pan = re.compile('panel.cfg',re.I)
    pan_list = []
    snd = re.compile('sound.cfg',re.I)
    snd_list = []
    for i in range(len(list)):
        if air.match(os.path.basename(list[i])) != None:
            air_list += cfg_get_keys(list[i],'fltsim.',['title'])
        elif pan.match(os.path.basename(list[i])) != None:
            pan_list += [list[i]]
        elif snd.match(os.path.basename(list[i])) != None:
            snd_list += [list[i]]
    return [air_list,pan_list,snd_list]
