#   Copyright (C) 2003 Nicolas Centa
 
#   This program is free software; you can redistribute it and/or
#   modify it under the terms of the GNU General Public License as
#   published by the Free Software Foundation; either version 2 of the
#   License, or (at your option) any later version.
 
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
 
#   You should have received a copy of the GNU General Public License
#   along with this program; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
#   USA

import os.path
import pygtk
pygtk.require('2.0')
import gtk
import gtk.glade

class PyFSconf_fselect:
    def __init__(self,on_response):
        self.xml = gtk.glade.XML('pyfsconf.glade','PyFSconf_fselect')
        self.connect()
        self.response_event = on_response
        
    def __getitem__(self, key):
        return self.xml.get_widget(key)
    
    def show(self):
        self['PyFSconf_fselect'].show()
        
    def on_response(widget,evt,self):
        self['PyFSconf_fselect'].hide()
        self.response_event(self['PyFSconf_fselect'].get_filename())
        
    def on_cancel(widget,evt,self):
        self['PyFSconf_fselect'].hide()
        
    def connect(self):
        self['PyFSconf_fselect'].ok_button.connect('clicked',self.on_response,self)
        self['PyFSconf_fselect'].cancel_button.connect('clicked',self.on_cancel,self)

class PyFSconf:
    def on_choose(self,widget):
        chooser = PyFSconf_fselect(self.on_response)
        chooser.show()
        
    def on_cancel(self,widget):
        self['PyFSconf'].hide()
        self.fspath = ''
        if self.on_ok != None:
            self.on_ok()
        
    def on_validate(self,widget):
        self['PyFSconf'].hide()
        self.fspath = self['fspath_txt'].get_text()
        if self.on_ok != None:
            self.on_ok()
            
    def __init__(self,on_ok = None):
        self.on_ok = on_ok
        self.fspath = ''
        self.xml = gtk.glade.XML('pyfsconf.glade','PyFSconf')
        self.event_table = {'on_validate':self.on_validate,'on_cancel':self.on_cancel,
                            'on_choose':self.on_choose}
        self.xml.signal_autoconnect(self.event_table)
        
    def launch(self):
        self['PyFSconf'].show()
        
    def __getitem__(self, key):
        return self.xml.get_widget(key)
        
    def on_response(self,filename):
        self['fspath_txt'].set_text(os.path.dirname(filename)+'/')
